export function makeCancelable(getPromise) {
    let canceled = false;
    return {
        getPromise: () => new Promise((resolve, reject) => {
            getPromise()
                .then((data) => {
                if (!canceled) {
                    resolve(data);
                }
            })
                .catch((error) => {
                if (!canceled) {
                    reject(error);
                }
            });
        }),
        cancel: () => {
            canceled = true;
        },
    };
}
//# sourceMappingURL=makeCancelable.js.map