import { usePromiseStateReducer } from "./usePromiseStateReducer";
export function usePromiseState() {
    const [{ completed, queued }, dispatch] = usePromiseStateReducer();
    const status = (() => {
        if (queued.length) {
            return "PENDING";
        }
        else if (!completed) {
            return "INITIAL";
        }
        return completed.status;
    })();
    const state = [
        completed && completed.status === "ERROR" ? completed.value : null,
        completed && completed.status === "SUCCESS" ? completed.value : null,
        status,
    ];
    return [state, dispatch];
}
//# sourceMappingURL=usePromiseState.js.map