/// <reference types="react" />
import { CancelablePromise } from "./makeCancelable";
declare type CompletedPromise<T> = {
    value: T;
    status: "SUCCESS";
} | {
    value: unknown;
    status: "ERROR";
};
declare type State<T> = {
    completed: CompletedPromise<T> | null;
    queued: CancelablePromise<T>[];
};
export declare type Actions<T> = {
    type: "ADD";
    promise: CancelablePromise<T>;
} | {
    type: "CLEANUP";
    promise: CancelablePromise<T>;
} | {
    type: "COMPLETE";
    result: CompletedPromise<T>;
    promise: CancelablePromise<T>;
} | {
    type: "RESET";
};
export declare type PromiseStateReducer<T> = (state: State<T>, action: Actions<T>) => State<T>;
export declare function usePromiseStateReducer<T>(): [State<T>, import("react").Dispatch<Actions<T>>];
export {};
